package org.openjdk.gcbench.alloc.uninit;

import jdk.internal.misc.Unsafe;
import org.openjdk.jmh.annotations.*;

import java.lang.reflect.Field;
import java.util.concurrent.TimeUnit;

@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@State(Scope.Benchmark)
@Fork(jvmArgsPrepend = {"--add-exports", "java.base/jdk.internal.misc=ALL-UNNAMED"})
public class IntArray {

    static final Unsafe U;
    static final long OFF_REF;

    static {
        try {
            Field unsafeField = Unsafe.class.getDeclaredField("theUnsafe");
            unsafeField.setAccessible(true);
            U = (Unsafe) unsafeField.get(null);
            OFF_REF  = U.objectFieldOffset(IntArray.class.getDeclaredField("ref"));
        } catch (Exception e) {
            throw new AssertionError(e);
        }
    }

    @Param({"1"})
    int size;

    @Benchmark
    public Object test() {
        return U.allocateUninitializedArray(int.class, size);
    }

}
